## INTRODUCTION

Do you want to install Drupal modules the right way (using composer) without having to use the command line?

This module gives you the best of both worlds: you can use Project Browser to search for modules but then install those modules in a secure way. All without having to learn how to use SSH or composer.

## REQUIREMENTS

You'll need to have SSH access available. That depends on your hosting plan. If you don't know, ask your host.

This module uses a helper application to do the heavy lifting. The application is written in Java so should run on any platform. The application is free, open source, and doesn't have ads.

## INSTALLATION

1. Make sure you have Java 17 installed. If you don't, search for instructions for your platform, it shouldn't be difficult.

2. Download the Sheephole application from Github. See [https://github.com/TolstoyDotCom/sheephole](github.com/TolstoyDotCom/sheephole) for instructions.

3. Run the Sheephole application and choose Profile > Create profile on the menu. Create a profile using the steps below. If you're unsure on any of this info, ask your host:
    - The 'Title' can be anything you want, such as the name of your site.
    - The 'Username' and 'Password' are what you use for SSH.
    - The 'URI' is the IP address or domain name for SSH. It shouldn't have "https" or slashes.
    - The 'Directory' is the path to your site on disk, like '/var/www/html/mysite'. There should be a file named 'composer.json' in that directory.

4. Choose Commands > Setup on the menu. Select the profile you created in the last step. If the password doesn't autopopulate, enter it. Then, press 'Install'. This will install this module and (if necessary) the Project Browser module into your installation.

5. On your site, choose 'Extend' on the top menu, or visit admin/modules. Enable both the Sheephole and Project Browser modules.

6. On the same page, click 'Browse' at the top to bring up the Project Browser page. As long as the Sheephole application is running, you should see an additional button with a download icon. Clicking that will open the application, ready to install the selected module.

## TROUBLESHOOTING

If something goes wrong and you get a message about authentication issues or the application can't find your installation, please double check the info with your host.
If there are other issues, please copy out any error messages and create an issue either here or on Github. Make sure to remove any personal info before posting your issue.

## ABOUT

Sheephole is named for a small, rugged mountain range near Joshua Tree that makes for a fun, challenging scramble.

This module and the application are written by:

- Chris Kelly - https://www.drupal.org/u/tolstoydotcom

Feel free to reach out if you would like to contract for a customized version or would like to have a module developed or updated.
